﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Collections.Generic;
using HeuristicLab.Core;
using HeuristicLab.Persistence;

namespace HeuristicLab.Problems.DataAnalysis {
  [StorableType("e2bff9b5-9252-4fd3-9c9e-17dcfea08fbf")]
  public interface IRegressionEnsembleSolution : IRegressionSolution {
    new IRegressionEnsembleModel Model { get; }
    new RegressionEnsembleProblemData ProblemData { get; set; }
    IItemCollection<IRegressionSolution> RegressionSolutions { get; }
    IEnumerable<IEnumerable<double>> GetEstimatedValueVectors(IEnumerable<int> rows);
  }
}
